diff --git a/src/dblib/unittests/t0018.sql b/src/dblib/unittests/t0018.sql
new file mode 100644
index 0000000..3de28a1
--- /dev/null
+++ b/src/dblib/unittests/t0018.sql
@@ -0,0 +1,107 @@
+create table #dblib0018 (i int not null, s char(10) not null)
+go
+insert into #dblib0018 values (0, 'row 000')
+go
+insert into #dblib0018 values (1, 'row 001')
+go
+insert into #dblib0018 values (2, 'row 002')
+go
+insert into #dblib0018 values (3, 'row 003')
+go
+insert into #dblib0018 values (4, 'row 004')
+go
+insert into #dblib0018 values (5, 'row 005')
+go
+insert into #dblib0018 values (6, 'row 006')
+go
+insert into #dblib0018 values (7, 'row 007')
+go
+insert into #dblib0018 values (8, 'row 008')
+go
+insert into #dblib0018 values (9, 'row 009')
+go
+insert into #dblib0018 values (10, 'row 010')
+go
+insert into #dblib0018 values (11, 'row 011')
+go
+insert into #dblib0018 values (12, 'row 012')
+go
+insert into #dblib0018 values (13, 'row 013')
+go
+insert into #dblib0018 values (14, 'row 014')
+go
+insert into #dblib0018 values (15, 'row 015')
+go
+insert into #dblib0018 values (16, 'row 016')
+go
+insert into #dblib0018 values (17, 'row 017')
+go
+insert into #dblib0018 values (18, 'row 018')
+go
+insert into #dblib0018 values (19, 'row 019')
+go
+insert into #dblib0018 values (20, 'row 020')
+go
+insert into #dblib0018 values (21, 'row 021')
+go
+insert into #dblib0018 values (22, 'row 022')
+go
+insert into #dblib0018 values (23, 'row 023')
+go
+insert into #dblib0018 values (24, 'row 024')
+go
+insert into #dblib0018 values (25, 'row 025')
+go
+insert into #dblib0018 values (26, 'row 026')
+go
+insert into #dblib0018 values (27, 'row 027')
+go
+insert into #dblib0018 values (28, 'row 028')
+go
+insert into #dblib0018 values (29, 'row 029')
+go
+insert into #dblib0018 values (30, 'row 030')
+go
+insert into #dblib0018 values (31, 'row 031')
+go
+insert into #dblib0018 values (32, 'row 032')
+go
+insert into #dblib0018 values (33, 'row 033')
+go
+insert into #dblib0018 values (34, 'row 034')
+go
+insert into #dblib0018 values (35, 'row 035')
+go
+insert into #dblib0018 values (36, 'row 036')
+go
+insert into #dblib0018 values (37, 'row 037')
+go
+insert into #dblib0018 values (38, 'row 038')
+go
+insert into #dblib0018 values (39, 'row 039')
+go
+insert into #dblib0018 values (40, 'row 040')
+go
+insert into #dblib0018 values (41, 'row 041')
+go
+insert into #dblib0018 values (42, 'row 042')
+go
+insert into #dblib0018 values (43, 'row 043')
+go
+insert into #dblib0018 values (44, 'row 044')
+go
+insert into #dblib0018 values (45, 'row 045')
+go
+insert into #dblib0018 values (46, 'row 046')
+go
+insert into #dblib0018 values (47, 'row 047')
+go
+insert into #dblib0018 values (48, 'row 048')
+go
+insert into #dblib0018 values (49, 'row 049')
+go
+select * into #tmp0 from #dblib0018
+select * from #tmp0 order by i
+go
+update #dblib0018 set s = 'row 000'
+go
diff --git a/src/dblib/unittests/t0020.c b/src/dblib/unittests/t0020.c
index aa8b4b9..90e0ec0 100644
--- a/src/dblib/unittests/t0020.c
+++ b/src/dblib/unittests/t0020.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0020.c,v 1.16 2008/11/25 22:58:29 jklowden Exp $";
+static char software_version[] = "$Id: t0020.c,v 1.17 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 
@@ -66,7 +66,7 @@ main(int argc, char **argv)
 	dbloginfree(login);
 	add_bread_crumb();
 
-	dbcmd(dbproc, "select dsjfkl dsjf");
+	sql_cmd(dbproc, INPUT);
 	fprintf(stderr, "The following invalid column error is normal.\n");
 
 	expected_error = 207;
@@ -79,7 +79,7 @@ main(int argc, char **argv)
 		exit(1);
 	}
 
-	dbcmd(dbproc, "select db_name()");
+	sql_cmd(dbproc, INPUT);
 	ret = dbsqlexec(dbproc);
 	if (ret != SUCCEED) {
 		failed = 1;
@@ -95,7 +95,7 @@ main(int argc, char **argv)
 	dbexit();
 	add_bread_crumb();
 
-	fprintf(stdout, "dblib %s on %s\n", (failed ? "failed!" : "okay"), __FILE__);
+	fprintf(stdout, "%s %s\n", __FILE__, (failed ? "failed!" : "OK"));
 	free_bread_crumb();
 	return failed ? 1 : 0;
 }
diff --git a/src/dblib/unittests/t0020.sql b/src/dblib/unittests/t0020.sql
new file mode 100644
index 0000000..927e0ac
--- /dev/null
+++ b/src/dblib/unittests/t0020.sql
@@ -0,0 +1,5 @@
+/* request an invalid column from a non-existent table */
+select dsjfkl dsjf
+go
+select db_name()
+go
diff --git a/src/dblib/unittests/t0021.c b/src/dblib/unittests/t0021.c
index 2d0c8d6..2c6bac9 100644
--- a/src/dblib/unittests/t0021.c
+++ b/src/dblib/unittests/t0021.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0021.c,v 1.13 2008/11/25 22:58:29 jklowden Exp $";
+static char software_version[] = "$Id: t0021.c,v 1.14 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 
@@ -59,6 +59,6 @@ main(int argc, char **argv)
 
 	dbexit();
 
-	fprintf(stdout, "dblib %s on %s\n", (failed ? "failed!" : "okay"), __FILE__);
+	fprintf(stdout, "%s %s\n", __FILE__, (failed ? "failed!" : "OK"));
 	return failed ? 1 : 0;
 }
diff --git a/src/dblib/unittests/t0022.c b/src/dblib/unittests/t0022.c
index 09eaf80..7a258b7 100644
--- a/src/dblib/unittests/t0022.c
+++ b/src/dblib/unittests/t0022.c
@@ -6,7 +6,7 @@
 #include "common.h"
 #include <assert.h>
 
-static char software_version[] = "$Id: t0022.c,v 1.25 2008/11/25 22:58:29 jklowden Exp $";
+static char software_version[] = "$Id: t0022.c,v 1.26 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 
@@ -56,7 +56,7 @@ main(int argc, char **argv)
 
 	fprintf(stdout, "Dropping proc\n");
 	add_bread_crumb();
-	dbcmd(dbproc, "if object_id('t0022') is not null drop proc t0022");
+	sql_cmd(dbproc, INPUT);
 	add_bread_crumb();
 	dbsqlexec(dbproc);
 	add_bread_crumb();
@@ -72,7 +72,7 @@ main(int argc, char **argv)
 	add_bread_crumb();
 
 	fprintf(stdout, "creating proc\n");
-	dbcmd(dbproc, "create proc t0022 (@b int out) as\nbegin\n select @b = 42\n return 66\nend\n");
+	sql_cmd(dbproc, INPUT);
 	if (dbsqlexec(dbproc) == FAIL) {
 		add_bread_crumb();
 		fprintf(stdout, "Failed to create proc t0022.\n");
@@ -88,7 +88,7 @@ main(int argc, char **argv)
 
 	sprintf(cmd, "declare @b int\nexec t0022 @b = @b output\n");
 	fprintf(stdout, "%s\n", cmd);
-	dbcmd(dbproc, cmd);
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	add_bread_crumb();
 
@@ -157,7 +157,7 @@ main(int argc, char **argv)
 
 	fprintf(stdout, "Dropping proc\n");
 	add_bread_crumb();
-	dbcmd(dbproc, "drop proc t0022");
+	sql_cmd(dbproc, INPUT);
 	add_bread_crumb();
 	dbsqlexec(dbproc);
 	add_bread_crumb();
@@ -170,7 +170,7 @@ main(int argc, char **argv)
 	 */
 	
 	fprintf(stdout, "Dropping proc t0022a\n");
-	dbcmd(dbproc, "if object_id('t0022a') is not null drop proc t0022a");
+	sql_cmd(dbproc, INPUT);
 
 	dbsqlexec(dbproc);
 
@@ -185,7 +185,7 @@ main(int argc, char **argv)
 	assert(erc == NO_MORE_RESULTS);
 
 	fprintf(stdout, "creating proc t0022a\n");
-	dbcmd(dbproc, "create proc t0022a (@b int) as\nreturn @b\n");
+	sql_cmd(dbproc, INPUT);
 	if (dbsqlexec(dbproc) == FAIL) {
 		fprintf(stdout, "Failed to create proc t0022a.\n");
 		exit(1);
@@ -198,9 +198,7 @@ main(int argc, char **argv)
 		assert(erc == NO_MORE_ROWS);
 	}
 
-	sprintf(cmd, "exec t0022a 17 exec t0022a 1024\n");
-	fprintf(stdout, "%s\n", cmd);
-	dbcmd(dbproc, cmd);
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 
 	for (i=1; (erc = dbresults(dbproc)) != NO_MORE_RESULTS; i++) {
@@ -234,7 +232,7 @@ main(int argc, char **argv)
 	assert(erc == NO_MORE_RESULTS);
 	
 	fprintf(stdout, "Dropping proc t0022a\n");
-	dbcmd(dbproc, "drop proc t0022a");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
@@ -247,7 +245,7 @@ main(int argc, char **argv)
 	dbexit();
 	add_bread_crumb();
 
-	fprintf(stdout, "dblib %s on %s\n", (failed ? "failed!" : "okay"), __FILE__);
+	fprintf(stdout, "%s %s\n", __FILE__, (failed ? "failed!" : "OK"));
 	free_bread_crumb();
 	return failed ? 1 : 0;
 }
diff --git a/src/dblib/unittests/t0022.sql b/src/dblib/unittests/t0022.sql
new file mode 100644
index 0000000..79c605a
--- /dev/null
+++ b/src/dblib/unittests/t0022.sql
@@ -0,0 +1,23 @@
+if object_id('t0022') is not null drop proc t0022
+go
+create proc t0022 (@b int out) as
+begin
+ select @b = 42
+ return 66
+end
+go
+declare @b int
+exec t0022 @b = @b output
+go
+drop proc t0022
+go
+if object_id('t0022a') is not null drop proc t0022a
+go
+create proc t0022a (@b int) as
+return @b
+go
+exec t0022a 17 
+exec t0022a 1024
+go
+drop proc t0022a
+go
diff --git a/src/dblib/unittests/t0023.c b/src/dblib/unittests/t0023.c
index 9d57529..515d880 100644
--- a/src/dblib/unittests/t0023.c
+++ b/src/dblib/unittests/t0023.c
@@ -6,7 +6,7 @@
 #include "common.h"
 #include <assert.h>
 
-static char software_version[] = "$Id: t0023.c,v 1.13 2008/11/25 22:58:29 jklowden Exp $";
+static char software_version[] = "$Id: t0023.c,v 1.14 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 
@@ -60,7 +60,7 @@ main(int argc, char *argv[])
 	add_bread_crumb();
 
 	fprintf(stdout, "creating table\n");
-	dbcmd(dbproc, "create table #dblib0023 (col1 int not null,  col2 char(1) not null, col3 datetime not null)");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) == SUCCEED) {
 		/* nop */
@@ -68,47 +68,34 @@ main(int argc, char *argv[])
 
 	fprintf(stdout, "insert\n");
 
-	strcpy(cmd, "insert into #dblib0023 values (1, 'A', 'Jan  1 2002 10:00:00AM')");
-	fprintf(stdout, "%s\n", cmd);
-	dbcmd(dbproc, cmd);
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) == SUCCEED) {
 		/* nop */
 	}
-	strcpy(cmd, "insert into #dblib0023 values (2, 'A', 'Jan  2 2002 10:00:00AM')");
-	fprintf(stdout, "%s\n", cmd);
-	dbcmd(dbproc, cmd);
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) == SUCCEED) {
 		/* nop */
 	}
-	strcpy(cmd, "insert into #dblib0023 values (3, 'A', 'Jan  3 2002 10:00:00AM')");
-	fprintf(stdout, "%s\n", cmd);
-	dbcmd(dbproc, cmd);
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) == SUCCEED) {
 		/* nop */
 	}
-	strcpy(cmd, "insert into #dblib0023 values (8, 'B', 'Jan  4 2002 10:00:00AM')");
-	fprintf(stdout, "%s\n", cmd);
-	dbcmd(dbproc, cmd);
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) == SUCCEED) {
 		/* nop */
 	}
-	strcpy(cmd, "insert into #dblib0023 values (9, 'B', 'Jan  5 2002 10:00:00AM')");
-	fprintf(stdout, "%s\n", cmd);
-	dbcmd(dbproc, cmd);
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) == SUCCEED) {
 		/* nop */
 	}
 
 	fprintf(stdout, "select\n");
-	strcpy(cmd, "select col1, col2, col3 from #dblib0023 order by col2 ");
-	strcat(cmd, "compute sum(col1) by col2 ");
-	strcat(cmd, "compute max(col3)");
-	dbcmd(dbproc, cmd);
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	add_bread_crumb();
 
@@ -241,7 +228,7 @@ main(int argc, char *argv[])
 	dbexit();
 	add_bread_crumb();
 
-	fprintf(stdout, "dblib %s on %s\n", (failed ? "failed!" : "okay"), __FILE__);
+	fprintf(stdout, "%s %s\n", __FILE__, (failed ? "failed!" : "OK"));
 	free_bread_crumb();
 	return failed ? 1 : 0;
 }
diff --git a/src/dblib/unittests/t0023.sql b/src/dblib/unittests/t0023.sql
new file mode 100644
index 0000000..e615da1
--- /dev/null
+++ b/src/dblib/unittests/t0023.sql
@@ -0,0 +1,14 @@
+create table #dblib0023 (col1 int not null,  col2 char(1) not null, col3 datetime not null)
+go
+insert into #dblib0023 values (1, 'A', 'Jan  1 2002 10:00:00AM')
+go
+insert into #dblib0023 values (2, 'A', 'Jan  2 2002 10:00:00AM')
+go
+insert into #dblib0023 values (3, 'A', 'Jan  3 2002 10:00:00AM')
+go
+insert into #dblib0023 values (8, 'B', 'Jan  4 2002 10:00:00AM')
+go
+insert into #dblib0023 values (9, 'B', 'Jan  5 2002 10:00:00AM')
+go
+select col1, col2, col3 from #dblib0023 order by col2 compute sum(col1) by col2 compute max(col3)
+go
diff --git a/src/dblib/unittests/text_buffer.c b/src/dblib/unittests/text_buffer.c
index 2af70a9..f0e2d20 100644
--- a/src/dblib/unittests/text_buffer.c
+++ b/src/dblib/unittests/text_buffer.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: text_buffer.c,v 1.4 2008/11/25 22:58:29 jklowden Exp $";
+static char software_version[] = "$Id: text_buffer.c,v 1.5 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 
@@ -59,19 +59,19 @@ main(int argc, char **argv)
 	add_bread_crumb();
 
 	fprintf(stdout, "creating table\n");
-	dbcmd(dbproc, "create table #dblib (i int not null, s text)");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
 	}
 
 	fprintf(stdout, "insert\n");
-	dbcmd(dbproc, "insert into #dblib values (1, 'ABCDEF')");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
 	}
-	dbcmd(dbproc, "insert into #dblib values (2, 'abc')");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
@@ -147,7 +147,7 @@ main(int argc, char **argv)
 	dbexit();
 	add_bread_crumb();
 
-	printf("dblib passed for %s\n", __FILE__);
+	fprintf(stdout, "%s %s\n", __FILE__, (0 ? "failed!" : "OK"));
 	free_bread_crumb();
 	return 0;
 }
diff --git a/src/dblib/unittests/text_buffer.sql b/src/dblib/unittests/text_buffer.sql
new file mode 100644
index 0000000..7aff639
--- /dev/null
+++ b/src/dblib/unittests/text_buffer.sql
@@ -0,0 +1,8 @@
+create table #dblib (i int not null, s text)
+go
+insert into #dblib values (1, 'ABCDEF')
+go
+insert into #dblib values (2, 'abc')
+go
+select * from #dblib order by i
+go
diff --git a/src/dblib/unittests/timeout.c b/src/dblib/unittests/timeout.c
index ea897ee..2431d0c 100644
--- a/src/dblib/unittests/timeout.c
+++ b/src/dblib/unittests/timeout.c
@@ -7,7 +7,7 @@
 #include "common.h"
 #include <time.h>
 
-static char software_version[] = "$Id: timeout.c,v 1.5 2008/11/25 22:58:29 jklowden Exp $";
+static char software_version[] = "$Id: timeout.c,v 1.6 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int ntimeouts = 0, ncancels = 0;
@@ -159,7 +159,7 @@ main(int argc, char **argv)
 	}
 	printf ("issuing a query that will take 30 seconds\n");
 
-	if (FAIL == dbcmd(dbproc, "select getdate() as 'begintime' waitfor delay '00:00:30' select getdate() as 'endtime' ")) {
+	if (FAIL == sql_cmd(dbproc, INPUT)) {
 		fprintf(stderr, "Failed: dbcmd\n");
 		exit(1);
 	}
@@ -237,7 +237,7 @@ main(int argc, char **argv)
 	dbexit();
 	add_bread_crumb();
 
-	fprintf(stdout, "dblib %s on %s\n", (failed ? "failed!" : "okay"), __FILE__);
+	fprintf(stdout, "%s %s\n", __FILE__, (failed ? "failed!" : "OK"));
 	free_bread_crumb();
 
 	return failed ? 1 : 0;
diff --git a/src/dblib/unittests/timeout.sql b/src/dblib/unittests/timeout.sql
new file mode 100644
index 0000000..2f40559
--- /dev/null
+++ b/src/dblib/unittests/timeout.sql
@@ -0,0 +1,2 @@
+select getdate() as 'begintime' waitfor delay '00:00:30' select getdate() as 'endtime' 
+go

